#include <stdio.h>
#include <stdlib.h>

int nzd(int a, int b) {
    // if (a == 0)
    //     return b;
    if (b == 0)
        return a;
    return nzd(b, a%b);
}

float stepen(float a, int n) {
    if (n == 0)
        return 1.0;
    else if (n < 0)
        return 1.0 / stepen(a, -n);
    return a * stepen(a, n-1);
}

int suma(int* a, int n) {
    if (n == 1)
        return a[0];
    //return a[0] + suma(a+1, n-1);
    return a[n-1] + suma(a, n-1);
}

void print_arr(int* a, int n) {
    if (n == 1) {
        printf("%d\n", a[0]);
        return;
    }
    printf("%d ", a[0]);
    print_arr(a+1, n-1);
}

// za vjezbu: min i max niza

void print_rev(int* a, int n) {
    if (n == 1) {
        printf("%d\n", a[0]);
        return;
    }
    printf("%d ", a[n-1]);
    print_rev(a, n-1);
}

int strlen_r(char* s) {
    if (s[0] == '\0')
        return 0;
    return 1 + strlen_r(s+1);
}

char* strchr_r(char* s, char c) {
    if (s[0] == c)
        return s;
    else if (s[0] == '\0')
        return NULL;
    else
        return strchr_r(s+1, c);
}

int suma_cifara(int n) {
    if (n < 10)
        return n;
    return n % 10 + suma_cifara(n / 10);
}

/**
Napisati rekurzivnu funkciju int evenDigits(int n) koja izbacuje sve parne cifre
datog prirodnog broja n. Ukoliko se n sastoji samo od parnih cifara, vratiti 0.
*/

int even_digits(int n) {
    if (n < 10) {
        if (n % 2 == 0)
            return 0;
        else
            return n;
    }
    int c = n % 10;
    if (c % 2 == 0)
        return even_digits(n / 10);
    else
        return even_digits(n / 10) * 10 + c;
}

/**
Napisati rekurzivnu funkciju int digitalRoot(int n) koja izračunava
digitalni korijen prirodnog broja n. Ako je suma cifara s(n) broja n
jednocifren broj, tada je s(n) digitalni korijen. Ako s(n) nije jednocifren,
tada se postupak ponavlja sa s(n) sve dok se ne dobije jednocifren broj.
*/

int digital_root(int n) {
    int s = suma_cifara(n);
    if (s < 10)
        return s;
    else
        return digital_root(s);
}

void permutacije(int n, int* p, int k) {
    if (k == n) {
        int i;
        for (i = 0; i < n; i++) {
            printf("%d ", p[i]);
        }
        printf("\n");
        return;
    }
    int i;
    for (i = 1; i <= n; i++) {
        int j;
        int ind = 0;
        for (j = 0; j < k; j++) {
            if (p[j] == i) {
                ind = 1;
                break;
            }
        }
        if (ind == 0) {
            p[k] = i;
            permutacije(n, p, k+1);
        }
    }
}

int main()
{
    printf("%d\n", nzd(24, 60));
    printf("%f\n", stepen(2.0, 5));
    printf("%f\n", stepen(2.0, -2));

    int a[] = {1,2,3,4,5};
    printf("%d\n", suma(a, 5));
    print_arr(a, 5);
    print_rev(a, 5);

    printf("%d\n", strlen_r("abcd"));
    printf("%p\n", strchr_r("acbd", 'c'));
    printf("%p\n", strchr_r("acbd", 'x'));

    printf("%d\n", suma_cifara(2024));

    printf("%d\n", even_digits(1234));
    printf("%d\n", even_digits(2024));
    printf("%d\n", even_digits(2023));
    printf("%d\n", even_digits(111));

    printf("%d\n", digital_root(1234));
    printf("%d\n", digital_root(9999));

    int p[100];
    permutacije(3, p, 0);

    return 0;
}
